#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int MAX,x,y;
bool **mat;
int *konce;
int pocetkoncov;

void Nacitaj(void)
{
  char *p=(char *)calloc(x,sizeof(char));
  for (int i=0;i<y;i++)
  {
      scanf("%s",p);
      for (int j=0;j<x;j++)
      if (p[j]=='.')
        mat[j][i]=true;
  }
}

bool Hladaj(int x1,int y1,int x2,int y2,int r,int s1,int s2)
{
  if (x1==x2 && y1==y2)
  {
    if (r>MAX)
    {
      MAX=r;
      return true;
    }
  }
  else
  {
    if (x1>0 && mat[x1-1][y1] && (s1!=x1-1 || s2!=y1))
    {
      bool pombul=Hladaj(x1-1,y1,x2,y2,r+1,x1,y1);
      if (pombul)
        return true;
    }
    if (x1<x-1 && mat[x1+1][y1] && (s1!=x1+1 || s2!=y1))
    {
      bool pombul=Hladaj(x1+1,y1,x2,y2,r+1,x1,y1);
      if (pombul)
        return true;
    }
    if (y1>0 && mat[x1][y1-1] && (s1!=x1 || s2!=y1-1))
    {
      bool pombul=Hladaj(x1,y1-1,x2,y2,r+1,x1,y1);
      if (pombul)
        return true;
    }
    if (y1<y-1 && mat[x1][y1+1] && (s1!=x1 || s2!=y1+1))
    {
      bool pombul=Hladaj(x1,y1+1,x2,y2,r+1,x1,y1);
      if (pombul)
        return true;
    }
  }
  return false;
}

void Koniec(int i,int j)
{
  int pocetsus=0;
  if (i>0 && mat[i-1][j])
    pocetsus++;
  if (i<x-1 && mat[i+1][j])
    pocetsus++;
  if (j>0 && mat[i][j-1])
    pocetsus++;
  if (j<y-1 && mat[i][j+1])
    pocetsus++;
 if (pocetsus==1)
 {
   konce[pocetkoncov*2]=i;
   konce[pocetkoncov*2+1]=j;
   pocetkoncov++;
  } 
}

void Spracuj(void)
{
  pocetkoncov=0;
  konce=(int *)calloc(1000000,sizeof(int));
  for (int i=0;i<x;i++)
    for (int j=0;j<y;j++)
      Koniec(i,j);
  for (int i=0;i<pocetkoncov;i++)
    for (int j=0;j<pocetkoncov;j++)
      if (i<j)
        Hladaj(konce[i*2],konce[i*2+1],konce[j*2],konce[j*2+1],0,-1,-1);
  free(konce);      
  printf("Maximum rope length is %i.\n",MAX);
}

int main(void)
{
  int poc;
  scanf("%i",&poc);
  for (int i=0;i<poc;i++)
  {
    MAX=0;
    scanf("%i %i",&x,&y);
    mat=(bool **)calloc(x,sizeof(bool *));
    for (int j=0;j<x;j++)
      mat[j]=(bool *)calloc(y,sizeof(bool));
      
    Nacitaj();
    Spracuj();
    
    for (int j=0;j<x;j++)
      free(mat[j]);
    free(mat);
  }
  return 0;
}