#include <stdio.h>
#include <stdlib.h>

int MAX,x,y;
bool **mat;

bool JeVCeste(int i,int j,int *c,int k)
{
  for (int o=0;o<k;o++)
    if (c[o]/y==i && c[o]%y==j)
      return true;
  return false;
}

void Nacitaj(void)
{
  char *p=(char *)calloc(x,sizeof(char));
  for (int i=0;i<y;i++)
  {
      scanf("%s",p);
      for (int j=0;j<x;j++)
      if (p[j]=='.')
        mat[j][i]=true;
  }
}

bool Hladaj(int x1,int y1,int x2,int y2,int r,int *cesta,int k)
{
  if (x1==x2 && y1==y2)
  {
    if (r>MAX)
    {
      MAX=r;
      return true;
    }
  }
  else
  {
    if (x1>0 && mat[x1-1][y1] && !JeVCeste(x1-1,y1,cesta,k))
    {
      int *pom=(int *)calloc(k+2,sizeof(int));
      for (int i=0;i<k;i++)
        pom[i]=cesta[i];
      pom[k]=(x1-1)*y+y1;
      bool pombul=Hladaj(x1-1,y1,x2,y2,r+1,pom,k+1);
      free(pom);
      if (pombul)
        return true;
    }
    if (x1<x-1 && mat[x1+1][y1] && !JeVCeste(x1+1,y1,cesta,k))
    {
      int *pom=(int *)calloc(k+2,sizeof(int));
      for (int i=0;i<k;i++)
        pom[i]=cesta[i];
      pom[k]=(x1+1)*y+y1;
      bool pombul=Hladaj(x1+1,y1,x2,y2,r+1,pom,k+1);
      free(pom);
      if (pombul)
        return true;
    }
    if (y1>0 && mat[x1][y1-1] && !JeVCeste(x1,y1-1,cesta,k))
    {
      int *pom=(int *)calloc(k+2,sizeof(int));
      for (int i=0;i<k;i++)
        pom[i]=cesta[i];
      pom[k]=x1*y+(y1-1);
      bool pombul=Hladaj(x1,y1-1,x2,y2,r+1,pom,k+1);
      free(pom);
      if (pombul)
        return true;
    }
    if (y1<y-1 && mat[x1][y1+1] && !JeVCeste(x1,y1+1,cesta,k))
    {
      int *pom=(int *)calloc(k+2,sizeof(int));
      for (int i=0;i<k;i++)
        pom[i]=cesta[i];
      pom[k]=x1*y+(y1+1);
      bool pombul=Hladaj(x1,y1+1,x2,y2,r+1,pom,k+1);
      free(pom);
      if (pombul)
        return true;
    }
  }
  return false;
}

void Spracuj(void)
{
  for (int i=0;i<x*y;i++)
    for (int j=0;j<x*y;j++)
      if (i!=j && mat[i/y][i%y] && mat[j/y][j%y])
      {
        int *c=(int *)calloc(2,sizeof(int));
        c[0]=i;
        Hladaj(i/y,i%y,j/y,j%y,0,c,1);
        free(c);
      }
  printf("Maximum rope length is %i.\n",MAX);
}

int main(void)
{
  int poc;
  scanf("%i",&poc);
  for (int i=0;i<poc;i++)
  {
    MAX=0;
    scanf("%i %i",&x,&y);
    mat=(bool **)calloc(x,sizeof(bool *));
    for (int j=0;j<x;j++)
      mat[j]=(bool *)calloc(y,sizeof(bool));
      
    Nacitaj();
    Spracuj();
    
    for (int j=0;j<x;j++)
      free(mat[j]);
    free(mat);
  }
  return 0;
}