#include <stdio.h>
#include <string.h>
#include <stdlib.h>

int **znaky;
char *konce;
int pocet;
bool *uz;

bool Hladaj(bool *UZ,int POC,char konc)
{
  if (POC==pocet)
  {
    printf("Ordering is possible.\n");
    return true;
  }
  else
  {
    for (int i=0;i<znaky[konc-'a'][0];i++)
    {
      if (!UZ[znaky[konc-'a'][i+1]])
      {
        bool *pomUZ=(bool *)calloc(pocet,sizeof(bool));
	for (int j=0;j<pocet;j++)
	  pomUZ[j]=UZ[j];
	pomUZ[znaky[konc-'a'][i+1]]=true;
	bool pomBUL=Hladaj(pomUZ,POC+1,konce[znaky[konc-'a'][i+1]]);
	free(pomUZ);
	if (pomBUL)
	  return pomBUL;
      }
    }
  }
  return false;
}

void Spracuj(void)
{
  bool a=false;
  int poc=1;
  uz=(bool *)calloc(pocet,sizeof(bool));
  for (int i=0;i<pocet && !a;i++)
  {
    if (i>0)
      uz[i-1]=false;
    uz[i]=true;
    a=Hladaj(uz,poc,konce[i]);
  }
  if (!a)
    printf("The door cannot be opened.\n");
  free(uz);
}

int main(void)
{
  int poc;
  scanf("%i",&poc);
  for (int i=0;i<poc;i++)
  {
    scanf("%i",&pocet);
    znaky=(int **)calloc(26,sizeof(int *));
    for (int j=0;j<26;j++)
      znaky[j]=(int *)calloc(pocet+1,sizeof(int));
    konce=(char *)calloc(pocet,sizeof(char));
    
    char *pom=(char *)calloc(1001,sizeof(char));
    for (int j=0;j<pocet;j++)
    {
      scanf("%s",pom);
      znaky[pom[0]-'a'][znaky[pom[0]-'a'][0]+1]=j;
      znaky[pom[0]-'a'][0]++;
      konce[j]=pom[strlen(pom)-1];
    }
    free(pom);
    Spracuj();
    
    for (int j=0;j<26;j++)
      free(znaky[j]);
    free(znaky);
    free(konce);
  }
  return 0;
}